/*
 * Copyright (c) 2020 Alex aka mailoman <alex@webz.asia>
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 *   @author Alex aka mailoman <alex@webz.asia>
 *   @copyright Copyright (c) 2020 Alex aka mailoman <alex@webz.asia>
 *   @since 08.01.2020
 *
 */

package version

type buildInfo struct {
	version string
	hash    string
	time    string
}

var (
	BuildVersion    = "unknown"
	BuildHash       = "unknown"
	BuildTime       = "unknown"
	serverBuildInfo *buildInfo
)

func init() {
	serverBuildInfo = New()
}

func New() *buildInfo {
	if serverBuildInfo == nil {
		serverBuildInfo = &buildInfo{
			BuildVersion, BuildHash, BuildTime,
		}
	}
	return serverBuildInfo
}

func Version() string {
	return serverBuildInfo.version
}

func Build() string {
	return serverBuildInfo.hash
}

func Time() string {
	return serverBuildInfo.time
}
